! $Id: WinImagingComponent.f90 2118 2016-05-13 02:54:23Z ian $
! Copyright 2016 M.E.G.M.S.  See LICENCE.txt for licence (Apache 2.0).



!*******************************************************************************

MODULE WinImagingComponent
  
  USE COMBase
  
  USE, INTRINSIC :: ISO_C_BINDING, ONLY:  &
      C_PTR,  &
      C_FUNPTR,  &
      C_INT32_T,  &
      C_INT16_T,  &
      C_SIGNED_CHAR
  
  IMPLICIT NONE
  
  
  !-----------------------------------------------------------------------------
  ! Isolated definition.
  
  ! We call this SINT instead of just INT, because otherwise we hide 
  ! the INT intrinsic, which is pretty handy.
  INTEGER, PARAMETER, PUBLIC :: SINT = C_INT32_T
  INTEGER, PARAMETER, PUBLIC :: UINT = C_INT32_T
  
  TYPE, EXTENDS(IUnknown) :: IStream
  END TYPE IStream
  
  !-----------------------------------------------------------------------------
  ! Definitions follow wincodec.h, from the v7.0A SDK.
  
  
  TYPE(GUID) :: CLSID_WICImagingFactory = GUID(  &
        INT(Z'CACAF262', C_INT32_T),  &
        INT(Z'9370', C_INT16_T),  &
        INT(Z'4615', C_INT16_T),  &
        [ INT(Z'A1', C_SIGNED_CHAR), INT(Z'3B', C_SIGNED_CHAR),  &
          INT(Z'9F', C_SIGNED_CHAR), INT(Z'55', C_SIGNED_CHAR),  &
          INT(Z'39', C_SIGNED_CHAR), INT(Z'DA', C_SIGNED_CHAR),  &
          INT(Z'4C', C_SIGNED_CHAR), INT(Z'0A', C_SIGNED_CHAR) ] )
  
  
  INTEGER, PARAMETER, PUBLIC :: WICColor = UINT32
  
  
  TYPE, BIND(C), PUBLIC :: WICRect
    INTEGER(SINT) :: X
    INTEGER(SINT) :: Y
    INTEGER(SINT) :: Width
    INTEGER(SINT) :: Height
  END TYPE WICRect
  
  
  ! WICInProcPointer
  
  
  INTEGER, PARAMETER, PUBLIC :: WICColorContextType = DWORD
  INTEGER(WICColorContextType), PARAMETER, PUBLIC  &
      :: WICColorContextUninitialized = 0
  INTEGER(WICColorContextType), PARAMETER, PUBLIC  &
      :: WICColorContextProfile = 1
  INTEGER(WICColorContextType), PARAMETER, PUBLIC  &
      :: WICColorContextExifColorSpace = 2
  
  
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormatDontCare  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'00', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat1bppIndexed  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'01', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat2bppIndexed  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'02', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat4bppIndexed  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'03', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat8bppIndexed  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'04', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormatBlackWhite  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'05', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat2bppGray  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'06', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat4bppGray  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'07', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat8bppGray  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'08', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat8bppAlpha  &
      = GUID(  &
        INT(Z'E6CD0116', C_INT32_T),  &
        INT(Z'EEBA', C_INT16_T),  &
        INT(Z'4161', C_INT16_T),  &
        [ INT(Z'AA', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'27', C_SIGNED_CHAR), INT(Z'DD', C_SIGNED_CHAR),  &
          INT(Z'9F', C_SIGNED_CHAR), INT(Z'B3', C_SIGNED_CHAR),  &
          INT(Z'A8', C_SIGNED_CHAR), INT(Z'95', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat16bppBGR555  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'09', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat16bppBGR565  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'0A', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat16bppBGRA5551  &
      = GUID(  &
        INT(Z'05EC7C2B', C_INT32_T),  &
        INT(Z'F1E6', C_INT16_T),  &
        INT(Z'4961', C_INT16_T),  &
        [ INT(Z'AD', C_SIGNED_CHAR), INT(Z'46', C_SIGNED_CHAR),  &
          INT(Z'E1', C_SIGNED_CHAR), INT(Z'CC', C_SIGNED_CHAR),  &
          INT(Z'81', C_SIGNED_CHAR), INT(Z'0A', C_SIGNED_CHAR),  &
          INT(Z'87', C_SIGNED_CHAR), INT(Z'D2', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat16bppGray  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'0B', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat24bppBGR  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'0C', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat24bppRGB  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'0D', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat32bppBGR  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'0E', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat32bppBGRA  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'0F', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat32bppPBGRA  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'10', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat32bppGrayFloat  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'11', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat32bppRGBA  &
      = GUID(  &
        INT(Z'F5C7AD2D', C_INT32_T),  &
        INT(Z'6A8D', C_INT16_T),  &
        INT(Z'43DD', C_INT16_T),  &
        [ INT(Z'A7', C_SIGNED_CHAR), INT(Z'A8', C_SIGNED_CHAR),  &
          INT(Z'A2', C_SIGNED_CHAR), INT(Z'99', C_SIGNED_CHAR),  &
          INT(Z'35', C_SIGNED_CHAR), INT(Z'26', C_SIGNED_CHAR),  &
          INT(Z'1A', C_SIGNED_CHAR), INT(Z'E9', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat32bppPRGBA  &
      = GUID(  &
        INT(Z'3CC4A650', C_INT32_T),  &
        INT(Z'A527', C_INT16_T),  &
        INT(Z'4D37', C_INT16_T),  &
        [ INT(Z'A9', C_SIGNED_CHAR), INT(Z'16', C_SIGNED_CHAR),  &
          INT(Z'31', C_SIGNED_CHAR), INT(Z'42', C_SIGNED_CHAR),  &
          INT(Z'C7', C_SIGNED_CHAR), INT(Z'EB', C_SIGNED_CHAR),  &
          INT(Z'ED', C_SIGNED_CHAR), INT(Z'BA', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat48bppRGB  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'15', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat48bppBGR  &
      = GUID(  &
        INT(Z'E605A384', C_INT32_T),  &
        INT(Z'B468', C_INT16_T),  &
        INT(Z'46CE', C_INT16_T),  &
        [ INT(Z'BB', C_SIGNED_CHAR), INT(Z'2E', C_SIGNED_CHAR),  &
          INT(Z'36', C_SIGNED_CHAR), INT(Z'F1', C_SIGNED_CHAR),  &
          INT(Z'80', C_SIGNED_CHAR), INT(Z'E6', C_SIGNED_CHAR),  &
          INT(Z'43', C_SIGNED_CHAR), INT(Z'13', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat64bppRGBA  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'16', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat64bppBGRA  &
      = GUID(  &
        INT(Z'1562FF7C', C_INT32_T),  &
        INT(Z'D352', C_INT16_T),  &
        INT(Z'46F9', C_INT16_T),  &
        [ INT(Z'97', C_SIGNED_CHAR), INT(Z'9E', C_SIGNED_CHAR),  &
          INT(Z'42', C_SIGNED_CHAR), INT(Z'97', C_SIGNED_CHAR),  &
          INT(Z'6B', C_SIGNED_CHAR), INT(Z'79', C_SIGNED_CHAR),  &
          INT(Z'22', C_SIGNED_CHAR), INT(Z'46', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat64bppPRGBA  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'17', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat64bppPBGRA  &
      = GUID(  &
        INT(Z'8C518E8E', C_INT32_T),  &
        INT(Z'A4EC', C_INT16_T),  &
        INT(Z'468B', C_INT16_T),  &
        [ INT(Z'AE', C_SIGNED_CHAR), INT(Z'70', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'A3', C_SIGNED_CHAR),  &
          INT(Z'5A', C_SIGNED_CHAR), INT(Z'9C', C_SIGNED_CHAR),  &
          INT(Z'55', C_SIGNED_CHAR), INT(Z'30', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat16bppGrayFixedPoint  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'13', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat32bppBGR101010  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'14', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat48bppRGBFixedPoint  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'12', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat48bppBGRFixedPoint  &
      = GUID(  &
        INT(Z'49CA140E', C_INT32_T),  &
        INT(Z'CAB6', C_INT16_T),  &
        INT(Z'493B', C_INT16_T),  &
        [ INT(Z'9D', C_SIGNED_CHAR), INT(Z'DF', C_SIGNED_CHAR),  &
          INT(Z'60', C_SIGNED_CHAR), INT(Z'18', C_SIGNED_CHAR),  &
          INT(Z'7C', C_SIGNED_CHAR), INT(Z'37', C_SIGNED_CHAR),  &
          INT(Z'53', C_SIGNED_CHAR), INT(Z'2A', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat96bppRGBFixedPoint  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'18', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat128bppRGBAFloat  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'19', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat128bppPRGBAFloat  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'1A', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat128bppRGBFloat  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'1B', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat32bppCMYK  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'1C', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat64bppRGBAFixedPoint  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'1D', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat64bppBGRAFixedPoint  &
      = GUID(  &
        INT(Z'356DE33C', C_INT32_T),  &
        INT(Z'54D2', C_INT16_T),  &
        INT(Z'4A23', C_INT16_T),  &
        [ INT(Z'BB', C_SIGNED_CHAR), INT(Z'04', C_SIGNED_CHAR),  &
          INT(Z'9B', C_SIGNED_CHAR), INT(Z'7B', C_SIGNED_CHAR),  &
          INT(Z'F9', C_SIGNED_CHAR), INT(Z'B1', C_SIGNED_CHAR),  &
          INT(Z'D4', C_SIGNED_CHAR), INT(Z'2D', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat64bppRGBFixedPoint  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'40', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat128bppRGBAFixedPoint  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'1E', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat128bppRGBFixedPoint  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'41', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat64bppRGBAHalf  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'3A', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat64bppRGBHalf  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'42', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat48bppRGBHalf  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'3B', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat32bppRGBE  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'3D', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat16bppGrayHalf  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'3E', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat32bppGrayFixedPoint  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'3F', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat32bppRGBA1010102  &
      = GUID(  &
        INT(Z'25238D72', C_INT32_T),  &
        INT(Z'FCF9', C_INT16_T),  &
        INT(Z'4522', C_INT16_T),  &
        [ INT(Z'B5', C_SIGNED_CHAR), INT(Z'14', C_SIGNED_CHAR),  &
          INT(Z'55', C_SIGNED_CHAR), INT(Z'78', C_SIGNED_CHAR),  &
          INT(Z'E5', C_SIGNED_CHAR), INT(Z'AD', C_SIGNED_CHAR),  &
          INT(Z'55', C_SIGNED_CHAR), INT(Z'E0', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat32bppRGBA1010102XR  &
      = GUID(  &
        INT(Z'00DE6B9A', C_INT32_T),  &
        INT(Z'C101', C_INT16_T),  &
        INT(Z'434B', C_INT16_T),  &
        [ INT(Z'B5', C_SIGNED_CHAR), INT(Z'02', C_SIGNED_CHAR),  &
          INT(Z'D0', C_SIGNED_CHAR), INT(Z'16', C_SIGNED_CHAR),  &
          INT(Z'5E', C_SIGNED_CHAR), INT(Z'E1', C_SIGNED_CHAR),  &
          INT(Z'12', C_SIGNED_CHAR), INT(Z'2C', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat64bppCMYK  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'1F', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat24bpp3Channels  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'20', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat32bpp4Channels  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'21', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat40bpp5Channels  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'22', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat48bpp6Channels  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'23', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat56bpp7Channels  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'24', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat64bpp8Channels  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'25', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat48bpp3Channels  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'26', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat64bpp4Channels  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'27', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat80bpp5Channels  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'28', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat96bpp6Channels  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'29', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat112bpp7Channels  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'2A', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat128bpp8Channels  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'2B', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat40bppCMYKAlpha  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'2C', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat80bppCMYKAlpha  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'2D', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat32bpp3ChannelsAlpha  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'2E', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat40bpp4ChannelsAlpha  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'2F', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat48bpp5ChannelsAlpha  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'30', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat56bpp6ChannelsAlpha  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'31', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat64bpp7ChannelsAlpha  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'32', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat72bpp8ChannelsAlpha  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'33', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat64bpp3ChannelsAlpha  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'34', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat80bpp4ChannelsAlpha  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'35', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat96bpp5ChannelsAlpha  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'36', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat112bpp6ChannelsAlpha  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'37', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat128bpp7ChannelsAlpha  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'38', C_SIGNED_CHAR) ] )
  TYPE(GUID), PARAMETER, PUBLIC :: GUID_WICPixelFormat144bpp8ChannelsAlpha  &
      = GUID(  &
        INT(Z'6FDDC324', C_INT32_T),  &
        INT(Z'4E03', C_INT16_T),  &
        INT(Z'4BFE', C_INT16_T),  &
        [ INT(Z'B1', C_SIGNED_CHAR), INT(Z'85', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'8D', C_SIGNED_CHAR),  &
          INT(Z'C9', C_SIGNED_CHAR), INT(Z'39', C_SIGNED_CHAR) ] )
  
  ! enum WICBitmapCreateCacheOption
  
  
  INTEGER, PARAMETER, PUBLIC :: WICDecodeOptions = DWORD
  INTEGER(WICDecodeOptions), PARAMETER, PUBLIC  &
      :: WICDecodeMetadataCacheOnDemand = 0
  INTEGER(WICDecodeOptions), PARAMETER, PUBLIC  &
      :: WICDecodeMetadataCacheOnLoad = 1
  
  
  ! enum WICComponentType
  ! enum WICComponentEnumerateOptions
  ! struct WICBitmapPattern
  ! enum WICBitmapInterpolationMode
  
  
  
  INTEGER, PARAMETER, PUBLIC :: WICBitmapPaletteType = DWORD
  INTEGER(WICBitmapPaletteType), PARAMETER, PUBLIC  &
      :: WICBitmapPaletteTypeCustom = 0
  INTEGER(WICBitmapPaletteType), PARAMETER, PUBLIC  &
      :: WICBitmapPaletteTypeMedianCut = 1
  INTEGER(WICBitmapPaletteType), PARAMETER, PUBLIC  &
      :: WICBitmapPaletteTypeFixedBW = 2
  INTEGER(WICBitmapPaletteType), PARAMETER, PUBLIC  &
      :: WICBitmapPaletteTypeFixedHalftone8 = 3
  INTEGER(WICBitmapPaletteType), PARAMETER, PUBLIC  &
      :: WICBitmapPaletteTypeFixedHalftone27 = 4
  INTEGER(WICBitmapPaletteType), PARAMETER, PUBLIC  &
      :: WICBitmapPaletteTypeFixedHalftone64 = 5
  INTEGER(WICBitmapPaletteType), PARAMETER, PUBLIC  &
      :: WICBitmapPaletteTypeFixedHalftone125 = 6
  INTEGER(WICBitmapPaletteType), PARAMETER, PUBLIC  &
      :: WICBitmapPaletteTypeFixedHalftone216 = 7
  INTEGER(WICBitmapPaletteType), PARAMETER, PUBLIC  &
      :: WICBitmapPaletteTypeFixedWebPalette  &
        = WICBitmapPaletteTypeFixedHalftone216
  INTEGER(WICBitmapPaletteType), PARAMETER, PUBLIC  &
      :: WICBitmapPaletteTypeFixedHalftone252 = 8
  INTEGER(WICBitmapPaletteType), PARAMETER, PUBLIC  &
      :: WICBitmapPaletteTypeFixedHalftone256 = 9
  INTEGER(WICBitmapPaletteType), PARAMETER, PUBLIC  &
      :: WICBitmapPaletteTypeFixedGray4 = 10
  INTEGER(WICBitmapPaletteType), PARAMETER, PUBLIC  &
      :: WICBitmapPaletteTypeFixedGray16 = 11
  INTEGER(WICBitmapPaletteType), PARAMETER, PUBLIC  &
      :: WICBitmapPaletteTypeFixedGray256 = 12
  
  
  INTEGER, PARAMETER, PUBLIC :: WICBitmapDitherType = DWORD
  INTEGER(WICBitmapDitherType), PARAMETER, PUBLIC  &
      :: WICBitmapDitherTypeNone = 0
  INTEGER(WICBitmapDitherType), PARAMETER, PUBLIC  &
      :: WICBitmapDitherTypeSolid = 0
  INTEGER(WICBitmapDitherType), PARAMETER, PUBLIC  &
      :: WICBitmapDitherTypeOrdered4x4 = 1
  INTEGER(WICBitmapDitherType), PARAMETER, PUBLIC  &
      :: WICBitmapDitherTypeOrdered8x8 = 2
  INTEGER(WICBitmapDitherType), PARAMETER, PUBLIC  &
      :: WICBitmapDitherTypeOrdered16x16 = 3
  INTEGER(WICBitmapDitherType), PARAMETER, PUBLIC  &
      :: WICBitmapDitherTypeSpiral4x4 = 4
  INTEGER(WICBitmapDitherType), PARAMETER, PUBLIC  &
      :: WICBitmapDitherTypeSpiral8x8 = 5
  INTEGER(WICBitmapDitherType), PARAMETER, PUBLIC  &
      :: WICBitmapDitherTypeDualSpiral4x4 = 6
  INTEGER(WICBitmapDitherType), PARAMETER, PUBLIC  &
      :: WICBitmapDitherTypeDualSpiral8x8 = 7
  INTEGER(WICBitmapDitherType), PARAMETER, PUBLIC  &
      :: WICBitmapDitherTypeErrorDiffusion = 8
  
  
  ! enum WICBitmapAlphaChannelOption
  ! enum WICBitmapTransformOptions
  ! enum WICBitmapLockFlags
  ! enum WICBitmapDecoderCapabilities
  ! enum WICProgressOperation
  ! enum WICProgressNotification
  ! enum WICComponentSigning
  ! enum WICGifLogicalScreenDescriptorProperties
  ! enum WICGifImageDescriptorProperties
  ! enum WICGifGraphicControlExtensionProperties
  ! enum WICGifApplicationExtensionProperties
  ! enum WICGifCommentExtensionProperties
  ! enum WICJpegCommentProperties
  ! enum WICJpegLuminanceProperties
  ! enum WICJpegChrominanceProperties
  ! enum WIC8BIMIptcProperties
  ! enum WIC8BIMResolutionInfoProperties
  ! enum WIC8BIMIptcDigestProperties
  ! enum WICPngGamaProperties
  ! enum WICPngBkgdProperties
  ! enum WICPngItxtProperties
  ! enum WICPngChrmProperties
  ! enum WICPngHistProperties
  ! enum WICPngIccpProperties
  ! enum WICPngSrgbProperties
  ! enum WICPngTimeProperties
  ! enum WICSectionAccessLevel
  ! enum WICPixelFormatNumericRepresentation
  
  
  !-----------------------------------------------------------------------------
  ! "00000040-a8f2-4877-ba0a-fd2b6645fb94"  IWICPalette
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IWICPalette
  CONTAINS
    PROCEDURE, NOPASS :: IID => palette_IID
  END TYPE IWICPalette
  
  !-----------------------------------------------------------------------------
  ! "00000120-a8f2-4877-ba0a-fd2b6645fb94"  IWICBitmapSource
  
  TYPE, BIND(C), PUBLIC :: IWICBitmapSourceVTbl
    TYPE(IUnknownVTbl) :: Base
    TYPE(C_FUNPTR) :: GetSize
    TYPE(C_FUNPTR) :: GetPixelFormat
    TYPE(C_FUNPTR) :: GetResolution
    TYPE(C_FUNPTR) :: CopyPalette
    TYPE(C_FUNPTR) :: CopyPixels
  END TYPE IWICBitmapSourceVTbl
  
  ABSTRACT INTERFACE
    FUNCTION GetSize_intf(this, puiWidth, puiHeight)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: UINT
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      INTEGER(UINT), INTENT(OUT) :: puiWidth
      !DEC$ ATTRIBUTES REFERENCE :: puiWidth
      INTEGER(UINT), INTENT(OUT) :: puiHeight
      !DEC$ ATTRIBUTES REFERENCE :: puiHeight
      INTEGER(HRESULT) :: GetSize_intf
      !DEC$ ATTRIBUTES STDCALL :: GetSize_intf
    END FUNCTION GetSize_intf
    
    FUNCTION GetPixelFormat_intf(this, pPixelFormat)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: GUID
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      TYPE(GUID), INTENT(OUT) :: pPixelFormat
      !DEC$ ATTRIBUTES REFERENCE :: pPixelFormat
      INTEGER(HRESULT) :: GetPixelFormat_intf
      !DEC$ ATTRIBUTES STDCALL :: GetPixelFormat_intf
    END FUNCTION GetPixelFormat_intf
    
    ! GetResolution
    ! CopyPalette
    
    FUNCTION CopyPixels_intf(this, prc, cbStride, cbBufferSize, pbBuffer)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: UINT
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      TYPE(C_PTR), INTENT(IN) :: prc            ! opt WICRect
      INTEGER(UINT), INTENT(IN) :: cbStride
      INTEGER(UINT), INTENT(IN) :: cbBufferSize
      TYPE(C_PTR), INTENT(IN) :: pbBuffer       ! out BYTE*
      INTEGER(HRESULT) :: CopyPixels_intf
      !DEC$ ATTRIBUTES STDCALL :: CopyPixels_intf
    END FUNCTION CopyPixels_intf
  END INTERFACE
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IWICBitmapSource
  CONTAINS
    PROCEDURE, NOPASS :: IID => bitmapsource_IID
  END TYPE IWICBitmapSource
  
  INTERFACE GetSize
    PROCEDURE :: GetSize_bs
  END INTERFACE GetSize
  PUBLIC :: GetSize
  
  !-----------------------------------------------------------------------------
  ! "00000301-a8f2-4877-ba0a-fd2b6645fb94"  IWICFormatConverter
  
  TYPE, BIND(C), PUBLIC :: IWICFormatConverterVTbl
    TYPE(IWICBitmapSourceVTbl) :: Base
    TYPE(C_FUNPTR) :: Initialize
    TYPE(C_FUNPTR) :: CanConvert
  END TYPE IWICFormatConverterVTbl
  
  ABSTRACT INTERFACE
    FUNCTION Initialize_intf( this, pISource, dstFormat, dither, pIPalette,  &
        alphaThresholdPercent, paletteTranslate )
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR, C_DOUBLE
      IMPORT :: GUID
      IMPORT :: WICBitmapDitherType
      IMPORT :: WICBitmapPaletteType
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      TYPE(C_PTR), INTENT(IN) :: pISource       ! opt in IWICBitmapSource
      TYPE(GUID), INTENT(IN) :: dstFormat
      !DEC$ ATTRIBUTES REFERENCE :: dstFormat
      INTEGER(WICBitmapDitherType), INTENT(IN) :: dither
      TYPE(C_PTR), INTENT(IN) :: pIPalette      ! opt in IWICPalette
      REAL(C_DOUBLE), INTENT(IN) :: alphaThresholdPercent
      INTEGER(WICBitmapPaletteType), INTENT(IN) :: paletteTranslate
      INTEGER(HRESULT) :: Initialize_intf
      !DEC$ ATTRIBUTES STDCALL :: Initialize_intf
    END FUNCTION Initialize_intf
    
    FUNCTION CanConvert_intf( this, srcPixelFormat, dstPixelFormat,  &
        pfCanConvert )
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: GUID
      IMPORT :: BOOL
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      TYPE(GUID), INTENT(IN) :: srcPixelFormat
      !DEC$ ATTRIBUTES REFERENCE :: srcPixelFormat
      TYPE(GUID), INTENT(IN) :: dstPixelFormat
      !DEC$ ATTRIBUTES REFERENCE :: dstPixelFormat
      INTEGER(BOOL), INTENT(OUT) :: pfCanConvert
      !DEC$ ATTRIBUTES REFERENCE :: pfCanConvert
      INTEGER(HRESULT) :: CanConvert_intf
      !DEC$ ATTRIBUTES STDCALL :: CanConvert_intf
    END FUNCTION CanConvert_intf
  END INTERFACE
  
  TYPE, EXTENDS(IWICBitmapSource), PUBLIC :: IWICFormatConverter
  CONTAINS
    PROCEDURE, NOPASS :: IID => formatconverter_IID
  END TYPE IWICFormatConverter
  
  PUBLIC :: Initialize
  PUBLIC :: CanConvert
  
  !-----------------------------------------------------------------------------
  ! "00000302-a8f2-4877-ba0a-fd2b6645fb94"  IWICBitmapScaler
  
  TYPE, EXTENDS(IWICBitmapSource), PUBLIC :: IWICBitmapScaler
  CONTAINS
    PROCEDURE, NOPASS :: IID => bitmapscaler_IID
  END TYPE IWICBitmapScaler
  
  !-----------------------------------------------------------------------------
  ! "E4FBCF03-223D-4e81-9333-D635556DD1B5"  IWICBitmapClipper
  
  TYPE, EXTENDS(IWICBitmapSource), PUBLIC :: IWICBitmapClipper
  CONTAINS
    PROCEDURE, NOPASS :: IID => bitmapclipper_IID
  END TYPE IWICBitmapClipper
  
  !-----------------------------------------------------------------------------
  ! "5009834F-2D6A-41ce-9E1B-17C5AFF7A782"  IWICBitmapFlipRotator
  
  TYPE, EXTENDS(IWICBitmapSource), PUBLIC :: IWICBitmapFlipRotator
  CONTAINS
    PROCEDURE, NOPASS :: IID => bitmapfliprotator_IID
  END TYPE IWICBitmapFlipRotator
  
  !-----------------------------------------------------------------------------
  ! "00000123-a8f2-4877-ba0a-fd2b6645fb94"  IWICBitmapLock
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IWICBitmapLock
  CONTAINS
    PROCEDURE, NOPASS :: IID => bitmaplock_IID
  END TYPE IWICBitmapLock
  
  !-----------------------------------------------------------------------------
  ! "00000121-a8f2-4877-ba0a-fd2b6645fb94"  IWICBitmap
  
  TYPE, EXTENDS(IWICBitmapSource), PUBLIC :: IWICBitmap
  CONTAINS
    PROCEDURE, NOPASS :: IID => bitmap_IID
  END TYPE IWICBitmap
  
  !-----------------------------------------------------------------------------
  ! "3C613A02-34B2-44ea-9A7C-45AEA9C6FD6D"  IWICColorContext
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IWICColorContext
  CONTAINS
    PROCEDURE, NOPASS :: IID => colorcontext_IID
  END TYPE IWICColorContext
  
  !-----------------------------------------------------------------------------
  ! "B66F034F-D0E2-40ab-B436-6DE39E321A94"  IWICColorTransform
  
  TYPE, EXTENDS(IWICBitmapSource), PUBLIC :: IWICColorTransform
  CONTAINS
    PROCEDURE, NOPASS :: IID => colortransform_IID
  END TYPE IWICColorTransform
  
  !-----------------------------------------------------------------------------
  ! "B84E2C09-78C9-4AC4-8BD3-524AE1663A2F"  IWICFastMetadataEncoder
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IWICFastMetadataEncoder
  CONTAINS
    PROCEDURE, NOPASS :: IID => fastmetadataencoder_IID
  END TYPE IWICFastMetadataEncoder
  
  !-----------------------------------------------------------------------------
  ! "135FF860-22B7-4ddf-B0F6-218F4F299A43"  IWICStream
  
  TYPE, EXTENDS(IStream), PUBLIC :: IWICStream
  CONTAINS
    PROCEDURE, NOPASS :: IID => stream_IID
  END TYPE IWICStream
  
  !-----------------------------------------------------------------------------
  ! "DC2BB46D-3F07-481E-8625-220C4AEDBB33"  IWICEnumMetadataItem
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IWICEnumMetadataItem
  CONTAINS
    PROCEDURE, NOPASS :: IID => enummetadataitem_IID
  END TYPE IWICEnumMetadataItem
  
  !-----------------------------------------------------------------------------
  ! "30989668-E1C9-4597-B395-458EEDB808DF"  IWICMetadataQueryReader
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IWICMetadataQueryReader
  CONTAINS
    PROCEDURE, NOPASS :: IID => metadataqueryreader_IID
  END TYPE IWICMetadataQueryReader
  
  !-----------------------------------------------------------------------------
  ! "A721791A-0DEF-4d06-BD91-2118BF1DB10B"  IWICMetadataQueryWriter
  
  TYPE, EXTENDS(IWICMetadataQueryReader), PUBLIC :: IWICMetadataQueryWriter
  CONTAINS
    PROCEDURE, NOPASS :: IID => metadataquerywriter_IID
  END TYPE IWICMetadataQueryWriter
  
  !-----------------------------------------------------------------------------
  ! "00000103-a8f2-4877-ba0a-fd2b6645fb94"  IWICBitmapEncoder
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IWICBitmapEncoder
  CONTAINS
    PROCEDURE, NOPASS :: IID => bitmapencoder_IID
  END TYPE IWICBitmapEncoder
  
  !-----------------------------------------------------------------------------
  ! "00000105-a8f2-4877-ba0a-fd2b6645fb94"  IWICBitmapFrameEncode
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IWICBitmapFrameEncode
  CONTAINS
    PROCEDURE, NOPASS :: IID => bitmapframeencode_IID
  END TYPE IWICBitmapFrameEncode
  
  !-----------------------------------------------------------------------------
  ! "9EDDE9E7-8DEE-47ea-99DF-E6FAF2ED44BF"  IWICBitmapDecoder
  
  TYPE, BIND(C), PUBLIC :: IWICBitmapDecoderVTbl
    TYPE(IUnknownVTbl) :: Base
    TYPE(C_FUNPTR) :: QueryCapability
    TYPE(C_FUNPTR) :: Initialize
    TYPE(C_FUNPTR) :: GetContainerFormat
    TYPE(C_FUNPTR) :: GetDecoderInfo
    TYPE(C_FUNPTR) :: CopyPalette
    TYPE(C_FUNPTR) :: GetMetadataQueryReader
    TYPE(C_FUNPTR) :: GetPreview
    TYPE(C_FUNPTR) :: GetColorContexts
    TYPE(C_FUNPTR) :: GetThumbnail
    TYPE(C_FUNPTR) :: GetFrameCount
    TYPE(C_FUNPTR) :: GetFrame
  END TYPE IWICBitmapDecoderVTbl
  
  ABSTRACT INTERFACE
    ! QueryCapability
    ! Initialize
    ! GetContainerFormat
    ! GetDecoderInfo
    ! CopyPalette
    ! GetMetadataQueryReader
    ! GetPreview
    ! GetColorContexts
    ! GetThumbnail
    FUNCTION GetFrameCount_intf(this, pCount)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: UINT
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      INTEGER(UINT), INTENT(OUT) :: pCount
      !DEC$ ATTRIBUTES REFERENCE :: pCount
      INTEGER(HRESULT) :: GetFrameCount_intf
      !DEC$ ATTRIBUTES STDCALL :: GetFrameCount_intf
    END FUNCTION GetFrameCount_intf
    
    FUNCTION GetFrame_intf(this, index, ppIBitmapFrame)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: UINT
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      INTEGER(UINT), INTENT(IN) :: index
      TYPE(C_PTR), INTENT(OUT) :: ppIBitmapFrame
      !DEC$ ATTRIBUTES REFERENCE :: ppIBitmapFrame
      INTEGER(HRESULT) :: GetFrame_intf
      !DEC$ ATTRIBUTES STDCALL :: GetFrame_intf
    END FUNCTION GetFrame_intf
  END INTERFACE
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IWICBitmapDecoder
  CONTAINS
    PROCEDURE, NOPASS :: IID => bitmapdecoder_IID
  END TYPE IWICBitmapDecoder
  
  PUBLIC :: GetFrame
  
  !-----------------------------------------------------------------------------
  ! "3B16811B-6A43-4ec9-B713-3D5A0C13B940"  IWICBitmapSourceTransform
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IWICBitmapSourceTransform
  CONTAINS
    PROCEDURE, NOPASS :: IID => bitmapsourcetransform_IID
  END TYPE IWICBitmapSourceTransform
  
  !-----------------------------------------------------------------------------
  ! "3B16811B-6A43-4ec9-A813-3D930C13B940"  IWICBitmapFrameDecode
  
  TYPE, EXTENDS(IWICBitmapSource), PUBLIC :: IWICBitmapFrameDecode
  CONTAINS
    PROCEDURE, NOPASS :: IID => bitmapframedecode_IID
  END TYPE IWICBitmapFrameDecode
  
  !-----------------------------------------------------------------------------
  ! "DAAC296F-7AA5-4dbf-8D15-225C5976F891"  IWICProgressiveLevelControl
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IWICProgressiveLevelControl
  CONTAINS
    PROCEDURE, NOPASS :: IID => progressivelevelcontrol_IID
  END TYPE IWICProgressiveLevelControl
  
  !-----------------------------------------------------------------------------
  ! "4776F9CD-9517-45FA-BF24-E89C5EC5C60C"  IWICProgressCallback
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IWICProgressCallback
  CONTAINS
    PROCEDURE, NOPASS :: IID => progresscallback_IID
  END TYPE IWICProgressCallback
  
  !-----------------------------------------------------------------------------
  ! "64C1024E-C3CF-4462-8078-88C2B11C46D9"  IWICBitmapCodecProgressNotification
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IWICBitmapCodecProgressNotification
  CONTAINS
    PROCEDURE, NOPASS :: IID => bitmapcodecprogressnotification_IID
  END TYPE IWICBitmapCodecProgressNotification
  
  !-----------------------------------------------------------------------------
  ! "23BC3F0A-698B-4357-886B-F24D50671334"  IWICComponentInfo
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IWICComponentInfo
  CONTAINS
    PROCEDURE, NOPASS :: IID => componentinfo_IID
  END TYPE IWICComponentInfo
  
  !-----------------------------------------------------------------------------
  ! "9F34FB65-13F4-4f15-BC57-3726B5E53D9F"  IWICFormatConverterInfo
  
  TYPE, EXTENDS(IWICComponentInfo), PUBLIC :: IWICFormatConverterInfo
  CONTAINS
    PROCEDURE, NOPASS :: IID => formatconverterinfo_IID
  END TYPE IWICFormatConverterInfo
  
  !-----------------------------------------------------------------------------
  ! "E87A44C4-B76E-4c47-8B09-298EB12A2714"  IWICBitmapCodecInfo
  
  TYPE, EXTENDS(IWICComponentInfo), PUBLIC :: IWICBitmapCodecInfo
  CONTAINS
    PROCEDURE, NOPASS :: IID => bitmapcodecinfo_IID
  END TYPE IWICBitmapCodecInfo
  
  !-----------------------------------------------------------------------------
  ! "94C9B4EE-A09F-4f92-8A1E-4A9BCE7E76FB"  IWICBitmapEncoderInfo
  
  TYPE, EXTENDS(IWICBitmapCodecInfo), PUBLIC :: IWICBitmapEncoderInfo
  CONTAINS
    PROCEDURE, NOPASS :: IID => bitmapencoderinfo_IID
  END TYPE IWICBitmapEncoderInfo
  
  !-----------------------------------------------------------------------------
  ! "D8CD007F-D08F-4191-9BFC-236EA7F0E4B5"  IWICBitmapDecoderInfo
  
  TYPE, EXTENDS(IWICBitmapCodecInfo), PUBLIC :: IWICBitmapDecoderInfo
  CONTAINS
    PROCEDURE, NOPASS :: IID => bitmapdecoderinfo_IID
  END TYPE IWICBitmapDecoderInfo
  
  !-----------------------------------------------------------------------------
  ! "E8EDA601-3D48-431a-AB44-69059BE88BBE"  IWICPixelFormatInfo
  
  TYPE, EXTENDS(IWICComponentInfo), PUBLIC :: IWICPixelFormatInfo
  CONTAINS
    PROCEDURE, NOPASS :: IID => pixelformatinfo_IID
  END TYPE IWICPixelFormatInfo
  
  !-----------------------------------------------------------------------------
  ! "A9DB33A2-AF5F-43C7-B679-74F5984B5AA4"  IWICPixelFormatInfo2
  
  TYPE, EXTENDS(IWICPixelFormatInfo), PUBLIC :: IWICPixelFormatInfo2
  CONTAINS
    PROCEDURE, NOPASS :: IID => pixelformatinfo2_IID
  END TYPE IWICPixelFormatInfo2
  
  !-----------------------------------------------------------------------------
  ! "ec5ec8a9-c395-4314-9c77-54d7a935ff70"  IWICImagingFactory
  
  TYPE, BIND(C) :: IWICImagingFactoryVTbl
    TYPE(IUnknownVTbl) :: Base
    TYPE(C_FUNPTR) :: CreateDecoderFromFilename
    TYPE(C_FUNPTR) :: CreateDecoderFromStream
    TYPE(C_FUNPTR) :: CreateDecoderFromFileHandle
    TYPE(C_FUNPTR) :: CreateComponentInfo
    TYPE(C_FUNPTR) :: CreateDecoder
    TYPE(C_FUNPTR) :: CreateEncoder
    TYPE(C_FUNPTR) :: CreatePalette
    TYPE(C_FUNPTR) :: CreateFormatConverter
    TYPE(C_FUNPTR) :: CreateBitmapScaler
    TYPE(C_FUNPTR) :: CreateBitmapClipper
    TYPE(C_FUNPTR) :: CreateBitmapFlipRotator
    TYPE(C_FUNPTR) :: CreateStream
    TYPE(C_FUNPTR) :: CreateColorContext
    TYPE(C_FUNPTR) :: CreateColorTransformer
    TYPE(C_FUNPTR) :: CreateBitmap
    TYPE(C_FUNPTR) :: CreateBitmapFromSource
    TYPE(C_FUNPTR) :: CreateBitmapFromSourceRect
    TYPE(C_FUNPTR) :: CreateBitmapFromMemory
    TYPE(C_FUNPTR) :: CreateBitmapFromHBITMAP
    TYPE(C_FUNPTR) :: CreateBitmapFromHICON
    TYPE(C_FUNPTR) :: CreateComponentEnumerator
    TYPE(C_FUNPTR) :: CreateFastMetadataEncoderFromDecoder
    TYPE(C_FUNPTR) :: CreateFastMetadataEncoderFromFrameDecode
    TYPE(C_FUNPTR) :: CreateQueryWriter
    TYPE(C_FUNPTR) :: CreateQueryWriterFromReader
  END TYPE IWICImagingFactoryVTbl
  
  ABSTRACT INTERFACE
    FUNCTION CreateDecoderFromFilename_intf( this, wzFilename, pguidVendor,  &
        dwDesiredAccess, metadataOptions, ppIDecoder )
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: WCHAR
      IMPORT :: DWORD
      IMPORT :: WICDecodeOptions
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      INTEGER(WCHAR), INTENT(IN) :: wzFilename(*)
      TYPE(C_PTR), INTENT(IN) :: pguidVendor
      INTEGER(DWORD), INTENT(IN) :: dwDesiredAccess
      INTEGER(WICDecodeOptions), INTENT(IN) :: metadataOptions
      TYPE(C_PTR), INTENT(OUT) :: ppIDecoder
      !DEC$ ATTRIBUTES REFERENCE :: ppIDecoder
      INTEGER(HRESULT) :: CreateDecoderFromFilename_intf
      !DEC$ ATTRIBUTES STDCALL :: CreateDecoderFromFilename_intf
    END FUNCTION CreateDecoderFromFilename_intf
    
    ! CreateDecoderFromStream
    ! CreateDecoderFromFileHandle
    ! CreateComponentInfo
    ! CreateDecoder
    ! CreateEncoder
    ! CreatePalette
    
    FUNCTION CreateFormatConverter_intf(this, ppIFormatConverter)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      TYPE(C_PTR), INTENT(OUT) :: ppIFormatConverter
      !DEC$ ATTRIBUTES REFERENCE :: ppIFormatConverter
      INTEGER(HRESULT) :: CreateFormatConverter_intf
      !DEC$ ATTRIBUTES STDCALL :: CreateFormatConverter_intf
    END FUNCTION CreateFormatConverter_intf
    
    ! CreateBitmapScaler
    ! CreateBitmapClipper
    ! CreateBitmapFlipRotator
    ! CreateStream
    ! CreateColorContext
    ! CreateColorTransformer
    ! CreateBitmap
    ! CreateBitmapFromSource
    ! CreateBitmapFromSourceRect
    ! CreateBitmapFromMemory
    ! CreateBitmapFromHBITMAP
    ! CreateBitmapFromHICON
    ! CreateComponentEnumerator
    ! CreateFastMetadataEncoderFromDecoder
    ! CreateFastMetadataEncoderFromFrameDecode
    ! CreateQueryWriter
    ! CreateQueryWriterFromReader
  END INTERFACE
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IWICImagingFactory
  CONTAINS
    PROCEDURE, NOPASS :: IID => imagingfactory_IID
  END TYPE IWICImagingFactory
  
  INTERFACE CreateDecoderFromFilename
    MODULE PROCEDURE :: CreateDecoderFromFilename_utf8
    MODULE PROCEDURE :: CreateDecoderFromFilename_utf16
  END INTERFACE CreateDecoderFromFilename
  PUBLIC :: CreateDecoderFromFilename
  PUBLIC :: CreateFormatConverter
  
  ! These are the access enumerations for CreateDecoderFromFilename, from 
  ! WinNT.h.
  INTEGER(DWORD), PARAMETER, PUBLIC :: GENERIC_READ  &
      = INT(Z'80000000', DWORD)
  INTEGER(DWORD), PARAMETER, PUBLIC :: GENERIC_WRITE  &
      = INT(Z'40000000', DWORD)
  INTEGER(DWORD), PARAMETER, PUBLIC :: GENERIC_EXECUTE  &
      = INT(Z'20000000', DWORD)
  INTEGER(DWORD), PARAMETER, PUBLIC :: GENERIC_ALL  &
      = INT(Z'10000000', DWORD)
  
  !-----------------------------------------------------------------------------
  
  INTERFACE
    FUNCTION WICConvertBitmapSource(dstFormat, pISrc, ppIDst)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: GUID
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(GUID), INTENT(IN) :: dstFormat
      !DEC$ ATTRIBUTES REFERENCE :: dstFormat
      TYPE(C_PTR), INTENT(IN) :: pISrc
      TYPE(C_PTR), INTENT(OUT) :: ppIDst
      !DEC$ ATTRIBUTES REFERENCE :: ppIDst
      INTEGER(HRESULT) :: WICConvertBitmapSource
      !DEC$ ATTRIBUTES STDCALL :: WICConvertBitmapSource
      !DEC$ ATTRIBUTES ALIAS:'WICConvertBitmapSource' :: WICConvertBitmapSource
      !DEC$ ATTRIBUTES DECORATE :: WICConvertBitmapSource
    END FUNCTION WICConvertBitmapSource
    
    ! WICCreateBitmapFromSection
    ! WICCreateBitmapFromSectionEx
    ! WICMapGuidToShortName
    ! WICMapShortNameToGuid
    ! WICMapSchemaNameToName
  END INTERFACE
  
  ! @todo Constants for error values.
  
  ! enum WICTiffCompressionOption
  ! enum WICJpegYCrCbSubsamplingOption
  ! enum WICPngFilterOption
  ! enum WICNamedWhitePoint
  ! enum WICRawCapabilities
  ! enum WICRawRotationCapabilities
  ! enum WICRawCapabilitiesInfo
  ! enum WICRawParameterSet
  ! enum WICRawRenderMode
  ! enum WICRawToneCurvePoint
  ! enum WICRawToneCurve
  
  ! @todo WICRawChangeNotification_* constants.
  
  !-----------------------------------------------------------------------------
  ! "95c75a6e-3e8c-4ec2-85a8-aebcc551e59b"  IWICDevelopRawNotificationCallback
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IWICDevelopRawNotificationCallback
  CONTAINS
    PROCEDURE, NOPASS :: IID => developrawnotificationcallback_IID
  END TYPE IWICDevelopRawNotificationCallback
  
  !-----------------------------------------------------------------------------
  ! "fbec5e44-f7be-4b65-b7f8-c0c81fef026d"  IWICDevelopRaw
  
  TYPE, EXTENDS(IWICBitmapFrameDecode), PUBLIC :: IWICDevelopRaw
  CONTAINS
    PROCEDURE, NOPASS :: IID => developraw_IID
  END TYPE IWICDevelopRaw
  
  !-----------------------------------------------------------------------------
  ! Some other helper procedures.
  
  ! Symmetric with the naming for the DWrite and D2D1 factories.
  PUBLIC :: WICCreateFactory
  
CONTAINS
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICPalette
  
  
  !*****************************************************************************
  
  FUNCTION palette_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: palette_IID
    
    !***************************************************************************
    
    palette_IID = GUID(  &
        INT(Z'00000040', C_INT32_T),  &
        INT(Z'A8F2', C_INT16_T),  &
        INT(Z'4877', C_INT16_T),  &
        [ INT(Z'BA', C_SIGNED_CHAR), INT(Z'0A', C_SIGNED_CHAR),  &
          INT(Z'FD', C_SIGNED_CHAR), INT(Z'2B', C_SIGNED_CHAR),  &
          INT(Z'66', C_SIGNED_CHAR), INT(Z'45', C_SIGNED_CHAR),  &
          INT(Z'FB', C_SIGNED_CHAR), INT(Z'94', C_SIGNED_CHAR) ] )
    
  END FUNCTION palette_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICBitmapSource
  
  
  !*****************************************************************************
  
  FUNCTION bitmapsource_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: bitmapsource_IID
    
    !***************************************************************************
    
    bitmapsource_IID = GUID(  &
        INT(Z'00000120', C_INT32_T),  &
        INT(Z'A8F2', C_INT16_T),  &
        INT(Z'4877', C_INT16_T),  &
        [ INT(Z'BA', C_SIGNED_CHAR), INT(Z'0A', C_SIGNED_CHAR),  &
          INT(Z'FD', C_SIGNED_CHAR), INT(Z'2B', C_SIGNED_CHAR),  &
          INT(Z'66', C_SIGNED_CHAR), INT(Z'45', C_SIGNED_CHAR),  &
          INT(Z'FB', C_SIGNED_CHAR), INT(Z'94', C_SIGNED_CHAR) ] )
    
  END FUNCTION bitmapsource_IID
  
  
  !*****************************************************************************
  
  SUBROUTINE GetSize_bs(bitmap_source, width, height, hr)
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_F_POINTER, C_F_PROCPOINTER
    
    !---------------------------------------------------------------------------
    ! Arguments
    
    CLASS(IWICBitmapSource), INTENT(IN) :: bitmap_source
    INTEGER, INTENT(OUT) :: width
    INTEGER, INTENT(OUT) :: height
    INTEGER(HRESULT), INTENT(OUT) :: hr
    
    !---------------------------------------------------------------------------
    ! Locals
    
    TYPE(IWICBitmapSourceVTbl), POINTER :: ptbl
    PROCEDURE(GetSize_intf), POINTER :: proc
    
    INTEGER :: local_width
    INTEGER :: local_height
    
    !***************************************************************************
    
    CALL C_F_POINTER(VTable(bitmap_source), ptbl)
    CALL C_F_PROCPOINTER(ptbl%GetSize, proc)
    
    hr = proc(bitmap_source%object, local_width, local_height)
    width = local_width
    height = local_height
    
  END SUBROUTINE GetSize_bs
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICFormatConverter
  
  
  !*****************************************************************************
  
  FUNCTION formatconverter_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: formatconverter_IID
    
    !***************************************************************************
    
    formatconverter_IID = GUID(  &
        INT(Z'00000301', C_INT32_T),  &
        INT(Z'A8F2', C_INT16_T),  &
        INT(Z'4877', C_INT16_T),  &
        [ INT(Z'BA', C_SIGNED_CHAR), INT(Z'0A', C_SIGNED_CHAR),  &
          INT(Z'FD', C_SIGNED_CHAR), INT(Z'2B', C_SIGNED_CHAR),  &
          INT(Z'66', C_SIGNED_CHAR), INT(Z'45', C_SIGNED_CHAR),  &
          INT(Z'FB', C_SIGNED_CHAR), INT(Z'94', C_SIGNED_CHAR) ] )
    
  END FUNCTION formatconverter_IID
  
  
  !*****************************************************************************
  
  SUBROUTINE Initialize( format_converter, pISource, dstFormat,  &
      hr, dither, pIPalette, alphaThresholdPercent, paletteTranslate )
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY:  &
        C_F_POINTER,  &
        C_F_PROCPOINTER,  &
        C_NULL_PTR,  &
        C_DOUBLE
    
    !---------------------------------------------------------------------------
    ! Arguments
    
    CLASS(IWICFormatConverter), INTENT(IN) :: format_converter
    CLASS(IWICBitmapSource), INTENT(IN) :: pISource
    TYPE(GUID), INTENT(IN) :: dstFormat
    INTEGER(HRESULT), INTENT(OUT) :: hr
    INTEGER(WICBitmapDitherType), INTENT(IN), OPTIONAL :: dither
    TYPE(IWICPalette), INTENT(IN), OPTIONAL :: pIPalette
    REAL(C_DOUBLE), INTENT(IN), OPTIONAL :: alphaThresholdPercent
    INTEGER(WICBitmapPaletteType), INTENT(IN), OPTIONAL :: paletteTranslate
    
    !---------------------------------------------------------------------------
    ! Locals
    
    TYPE(IWICFormatConverterVTbl), POINTER :: ptbl
    PROCEDURE(Initialize_intf), POINTER :: proc
    
    INTEGER(WICBitmapDitherType) :: local_dither
    TYPE(C_PTR) :: local_palette
    REAL(C_DOUBLE) :: local_alpha
    INTEGER(WICBitmapPaletteType) :: local_palette_type
    
    !***************************************************************************
    
    IF (PRESENT(dither)) THEN
      local_dither = dither
    ELSE
      local_dither = WICBitmapDitherTypeNone
    END IF
    
    IF (PRESENT(pIPalette)) THEN
      local_palette = pIPalette%object
    ELSE
      local_palette = C_NULL_PTR
    END IF
    
    IF (PRESENT(alphaThresholdPercent)) THEN
      local_alpha = alphaThresholdPercent
    ELSE
      local_alpha = 0.0_C_DOUBLE
    END IF
    
    IF (PRESENT(paletteTranslate)) THEN
      local_palette_type = paletteTranslate
    ELSE
      local_palette_type = WICBitmapPaletteTypeCustom
    END IF
    
    CALL C_F_POINTER(VTable(format_converter), ptbl)
    CALL C_F_PROCPOINTER(ptbl%Initialize, proc)
    
    hr = proc(  &
        format_converter%object,  &
        pISource%object,  &
        dstFormat,  &
        local_dither,  &
        local_palette,  &
        local_alpha,  &
        local_palette_type )
    
  END SUBROUTINE Initialize
  
  
  !*****************************************************************************
  
  SUBROUTINE CanConvert( format_converter, srcPixelFormat, dstPixelFormat,  &
      pfCanConvert, hr )
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_F_POINTER, C_F_PROCPOINTER
    
    !---------------------------------------------------------------------------
    ! Arguments
    
    CLASS(IWICFormatConverter), INTENT(IN) :: format_converter
    TYPE(GUID), INTENT(IN) :: srcPixelFormat
    TYPE(GUID), INTENT(IN) :: dstPixelFormat
    INTEGER(BOOL), INTENT(OUT) :: pfCanConvert
    INTEGER(HRESULT), INTENT(OUT) :: hr
    
    !---------------------------------------------------------------------------
    ! Locals
    
    TYPE(IWICFormatConverterVTbl), POINTER :: ptbl
    PROCEDURE(CanConvert_intf), POINTER :: proc
    
    !***************************************************************************
    
    CALL C_F_POINTER(VTable(format_converter), ptbl)
    CALL C_F_PROCPOINTER(ptbl%CanConvert, proc)
    
    hr = proc(  &
        format_converter%object,  &
        srcPixelFormat,  &
        dstPixelFormat,  &
        pfCanConvert )
    
  END SUBROUTINE CanConvert
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICBitmapScaler
  
  
  !*****************************************************************************
  
  FUNCTION bitmapscaler_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: bitmapscaler_IID
    
    !***************************************************************************
    
    bitmapscaler_IID = GUID(  &
        INT(Z'00000302', C_INT32_T),  &
        INT(Z'A8F2', C_INT16_T),  &
        INT(Z'4877', C_INT16_T),  &
        [ INT(Z'BA', C_SIGNED_CHAR), INT(Z'0A', C_SIGNED_CHAR),  &
          INT(Z'FD', C_SIGNED_CHAR), INT(Z'2B', C_SIGNED_CHAR),  &
          INT(Z'66', C_SIGNED_CHAR), INT(Z'45', C_SIGNED_CHAR),  &
          INT(Z'FB', C_SIGNED_CHAR), INT(Z'94', C_SIGNED_CHAR) ] )
    
  END FUNCTION bitmapscaler_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICBitmapClipper
  
  
  !*****************************************************************************
  
  FUNCTION bitmapclipper_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: bitmapclipper_IID
    
    !***************************************************************************
    
    bitmapclipper_IID = GUID(  &
        INT(Z'E4FBCF03', C_INT32_T),  &
        INT(Z'223D', C_INT16_T),  &
        INT(Z'4E81', C_INT16_T),  &
        [ INT(Z'93', C_SIGNED_CHAR), INT(Z'33', C_SIGNED_CHAR),  &
          INT(Z'D6', C_SIGNED_CHAR), INT(Z'35', C_SIGNED_CHAR),  &
          INT(Z'55', C_SIGNED_CHAR), INT(Z'6D', C_SIGNED_CHAR),  &
          INT(Z'D1', C_SIGNED_CHAR), INT(Z'B5', C_SIGNED_CHAR) ] )
    
  END FUNCTION bitmapclipper_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICBitmapFlipRotator
  
  
  !*****************************************************************************
  
  FUNCTION bitmapfliprotator_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: bitmapfliprotator_IID
    
    !***************************************************************************
    
    bitmapfliprotator_IID = GUID(  &
        INT(Z'5009834F', C_INT32_T),  &
        INT(Z'2D6A', C_INT16_T),  &
        INT(Z'41CE', C_INT16_T),  &
        [ INT(Z'9E', C_SIGNED_CHAR), INT(Z'1B', C_SIGNED_CHAR),  &
          INT(Z'17', C_SIGNED_CHAR), INT(Z'C5', C_SIGNED_CHAR),  &
          INT(Z'AF', C_SIGNED_CHAR), INT(Z'F7', C_SIGNED_CHAR),  &
          INT(Z'A7', C_SIGNED_CHAR), INT(Z'A2', C_SIGNED_CHAR) ] )
    
  END FUNCTION bitmapfliprotator_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICBitmapLock
  
  
  !*****************************************************************************
  
  FUNCTION bitmaplock_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: bitmaplock_IID
    
    !***************************************************************************
    
    bitmaplock_IID = GUID(  &
        INT(Z'00000123', C_INT32_T),  &
        INT(Z'A8F2', C_INT16_T),  &
        INT(Z'4877', C_INT16_T),  &
        [ INT(Z'BA', C_SIGNED_CHAR), INT(Z'0A', C_SIGNED_CHAR),  &
          INT(Z'FD', C_SIGNED_CHAR), INT(Z'2B', C_SIGNED_CHAR),  &
          INT(Z'66', C_SIGNED_CHAR), INT(Z'45', C_SIGNED_CHAR),  &
          INT(Z'FB', C_SIGNED_CHAR), INT(Z'94', C_SIGNED_CHAR) ] )
    
  END FUNCTION bitmaplock_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICBitmap
  
  
  !*****************************************************************************
  
  FUNCTION bitmap_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: bitmap_IID
    
    !***************************************************************************
    
    bitmap_IID = GUID(  &
        INT(Z'00000121', C_INT32_T),  &
        INT(Z'A8F2', C_INT16_T),  &
        INT(Z'4877', C_INT16_T),  &
        [ INT(Z'BA', C_SIGNED_CHAR), INT(Z'0A', C_SIGNED_CHAR),  &
          INT(Z'FD', C_SIGNED_CHAR), INT(Z'2B', C_SIGNED_CHAR),  &
          INT(Z'66', C_SIGNED_CHAR), INT(Z'45', C_SIGNED_CHAR),  &
          INT(Z'FB', C_SIGNED_CHAR), INT(Z'94', C_SIGNED_CHAR) ] )
    
  END FUNCTION bitmap_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICColorContext
  
  
  !*****************************************************************************
  
  FUNCTION colorcontext_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: colorcontext_IID
    
    !***************************************************************************
    
    colorcontext_IID = GUID(  &
        INT(Z'3C613A02', C_INT32_T),  &
        INT(Z'34B2', C_INT16_T),  &
        INT(Z'44EA', C_INT16_T),  &
        [ INT(Z'9A', C_SIGNED_CHAR), INT(Z'7C', C_SIGNED_CHAR),  &
          INT(Z'45', C_SIGNED_CHAR), INT(Z'AE', C_SIGNED_CHAR),  &
          INT(Z'A9', C_SIGNED_CHAR), INT(Z'C6', C_SIGNED_CHAR),  &
          INT(Z'FD', C_SIGNED_CHAR), INT(Z'6D', C_SIGNED_CHAR) ] )
    
  END FUNCTION colorcontext_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICColorTransform
  
  
  !*****************************************************************************
  
  FUNCTION colortransform_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: colortransform_IID
    
    !***************************************************************************
    
    colortransform_IID = GUID(  &
        INT(Z'B66F034F', C_INT32_T),  &
        INT(Z'D0E2', C_INT16_T),  &
        INT(Z'40AB', C_INT16_T),  &
        [ INT(Z'B4', C_SIGNED_CHAR), INT(Z'36', C_SIGNED_CHAR),  &
          INT(Z'6D', C_SIGNED_CHAR), INT(Z'E3', C_SIGNED_CHAR),  &
          INT(Z'9E', C_SIGNED_CHAR), INT(Z'32', C_SIGNED_CHAR),  &
          INT(Z'1A', C_SIGNED_CHAR), INT(Z'94', C_SIGNED_CHAR) ] )
    
  END FUNCTION colortransform_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICFastMetadataEncoder
  
  
  !*****************************************************************************
  
  FUNCTION fastmetadataencoder_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: fastmetadataencoder_IID
    
    !***************************************************************************
    
    fastmetadataencoder_IID = GUID(  &
        INT(Z'B84E2C09', C_INT32_T),  &
        INT(Z'78C9', C_INT16_T),  &
        INT(Z'4AC4', C_INT16_T),  &
        [ INT(Z'8B', C_SIGNED_CHAR), INT(Z'D3', C_SIGNED_CHAR),  &
          INT(Z'52', C_SIGNED_CHAR), INT(Z'4A', C_SIGNED_CHAR),  &
          INT(Z'E1', C_SIGNED_CHAR), INT(Z'66', C_SIGNED_CHAR),  &
          INT(Z'3A', C_SIGNED_CHAR), INT(Z'2F', C_SIGNED_CHAR) ] )
    
  END FUNCTION fastmetadataencoder_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICStream
  
  
  !*****************************************************************************
  
  FUNCTION stream_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: stream_IID
    
    !***************************************************************************
    
    stream_IID = GUID(  &
        INT(Z'135FF860', C_INT32_T),  &
        INT(Z'22B7', C_INT16_T),  &
        INT(Z'4DDF', C_INT16_T),  &
        [ INT(Z'B0', C_SIGNED_CHAR), INT(Z'F6', C_SIGNED_CHAR),  &
          INT(Z'21', C_SIGNED_CHAR), INT(Z'8F', C_SIGNED_CHAR),  &
          INT(Z'4F', C_SIGNED_CHAR), INT(Z'29', C_SIGNED_CHAR),  &
          INT(Z'9A', C_SIGNED_CHAR), INT(Z'43', C_SIGNED_CHAR) ] )
    
  END FUNCTION stream_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICEnumMetadataItem
  
  
  !*****************************************************************************
  
  FUNCTION enummetadataitem_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: enummetadataitem_IID
    
    !***************************************************************************
    
    enummetadataitem_IID = GUID(  &
        INT(Z'DC2BB46D', C_INT32_T),  &
        INT(Z'3F07', C_INT16_T),  &
        INT(Z'481E', C_INT16_T),  &
        [ INT(Z'86', C_SIGNED_CHAR), INT(Z'25', C_SIGNED_CHAR),  &
          INT(Z'22', C_SIGNED_CHAR), INT(Z'0C', C_SIGNED_CHAR),  &
          INT(Z'4A', C_SIGNED_CHAR), INT(Z'ED', C_SIGNED_CHAR),  &
          INT(Z'BB', C_SIGNED_CHAR), INT(Z'33', C_SIGNED_CHAR) ] )
    
  END FUNCTION enummetadataitem_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICMetadataQueryReader
  
  
  !*****************************************************************************
  
  FUNCTION metadataqueryreader_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: metadataqueryreader_IID
    
    !***************************************************************************
    
    metadataqueryreader_IID = GUID(  &
        INT(Z'30989668', C_INT32_T),  &
        INT(Z'E1C9', C_INT16_T),  &
        INT(Z'4597', C_INT16_T),  &
        [ INT(Z'B3', C_SIGNED_CHAR), INT(Z'95', C_SIGNED_CHAR),  &
          INT(Z'45', C_SIGNED_CHAR), INT(Z'8E', C_SIGNED_CHAR),  &
          INT(Z'ED', C_SIGNED_CHAR), INT(Z'B8', C_SIGNED_CHAR),  &
          INT(Z'08', C_SIGNED_CHAR), INT(Z'DF', C_SIGNED_CHAR) ] )
    
  END FUNCTION metadataqueryreader_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICMetadataQueryWriter
  
  
  !*****************************************************************************
  
  FUNCTION metadataquerywriter_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: metadataquerywriter_IID
    
    !***************************************************************************
    
    metadataquerywriter_IID = GUID(  &
        INT(Z'A721791A', C_INT32_T),  &
        INT(Z'0DEF', C_INT16_T),  &
        INT(Z'4D06', C_INT16_T),  &
        [ INT(Z'BD', C_SIGNED_CHAR), INT(Z'91', C_SIGNED_CHAR),  &
          INT(Z'21', C_SIGNED_CHAR), INT(Z'18', C_SIGNED_CHAR),  &
          INT(Z'BF', C_SIGNED_CHAR), INT(Z'1D', C_SIGNED_CHAR),  &
          INT(Z'B1', C_SIGNED_CHAR), INT(Z'0B', C_SIGNED_CHAR) ] )
    
  END FUNCTION metadataquerywriter_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICBitmapEncoder
  
  
  !*****************************************************************************
  
  FUNCTION bitmapencoder_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: bitmapencoder_IID
    
    !***************************************************************************
    
    bitmapencoder_IID = GUID(  &
        INT(Z'00000103', C_INT32_T),  &
        INT(Z'A8F2', C_INT16_T),  &
        INT(Z'4877', C_INT16_T),  &
        [ INT(Z'BA', C_SIGNED_CHAR), INT(Z'0A', C_SIGNED_CHAR),  &
          INT(Z'FD', C_SIGNED_CHAR), INT(Z'2B', C_SIGNED_CHAR),  &
          INT(Z'66', C_SIGNED_CHAR), INT(Z'45', C_SIGNED_CHAR),  &
          INT(Z'FB', C_SIGNED_CHAR), INT(Z'94', C_SIGNED_CHAR) ] )
    
  END FUNCTION bitmapencoder_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICBitmapFrameEncode
  
  
  !*****************************************************************************
  
  FUNCTION bitmapframeencode_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: bitmapframeencode_IID
    
    !***************************************************************************
    
    bitmapframeencode_IID = GUID(  &
        INT(Z'00000105', C_INT32_T),  &
        INT(Z'A8F2', C_INT16_T),  &
        INT(Z'4877', C_INT16_T),  &
        [ INT(Z'BA', C_SIGNED_CHAR), INT(Z'0A', C_SIGNED_CHAR),  &
          INT(Z'FD', C_SIGNED_CHAR), INT(Z'2B', C_SIGNED_CHAR),  &
          INT(Z'66', C_SIGNED_CHAR), INT(Z'45', C_SIGNED_CHAR),  &
          INT(Z'FB', C_SIGNED_CHAR), INT(Z'94', C_SIGNED_CHAR) ] )
    
  END FUNCTION bitmapframeencode_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICBitmapDecoder
  
  
  !*****************************************************************************
  
  FUNCTION bitmapdecoder_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: bitmapdecoder_IID
    
    !***************************************************************************
    
    bitmapdecoder_IID = GUID(  &
        INT(Z'9EDDE9E7', C_INT32_T),  &
        INT(Z'8DEE', C_INT16_T),  &
        INT(Z'47EA', C_INT16_T),  &
        [ INT(Z'99', C_SIGNED_CHAR), INT(Z'DF', C_SIGNED_CHAR),  &
          INT(Z'E6', C_SIGNED_CHAR), INT(Z'FA', C_SIGNED_CHAR),  &
          INT(Z'F2', C_SIGNED_CHAR), INT(Z'ED', C_SIGNED_CHAR),  &
          INT(Z'44', C_SIGNED_CHAR), INT(Z'BF', C_SIGNED_CHAR) ] )
    
  END FUNCTION bitmapdecoder_IID
  
  
  !*****************************************************************************
  
  SUBROUTINE GetFrame(bitmap_decoder, index, ppIBitmapFrame, hr)
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_F_POINTER, C_F_PROCPOINTER
    
    !---------------------------------------------------------------------------
    ! Arguments
    
    CLASS(IWICBitmapDecoder), INTENT(IN) :: bitmap_decoder
    
    INTEGER(UINT), INTENT(IN) :: index
    
    TYPE(IWICBitmapFrameDecode), INTENT(OUT) :: ppIBitmapFrame
    
    INTEGER(HRESULT), INTENT(OUT) :: hr
  
    !---------------------------------------------------------------------------
    ! Locals
    
    TYPE(IWICBitmapDecoderVTbl), POINTER :: ptbl
    PROCEDURE(GetFrame_intf), POINTER :: proc
    
    !***************************************************************************
    
    CALL C_F_POINTER(VTable(bitmap_decoder), ptbl)
    CALL C_F_PROCPOINTER(ptbl%GetFrame, proc)
    hr = proc(  &
        bitmap_decoder%object,  &
        index,  &
        ppIBitmapFrame%object )
    
  END SUBROUTINE GetFrame
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICBitmapSourceTransform
  
  
  !*****************************************************************************
  
  FUNCTION bitmapsourcetransform_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: bitmapsourcetransform_IID
    
    !***************************************************************************
    
    bitmapsourcetransform_IID = GUID(  &
        INT(Z'3B16811B', C_INT32_T),  &
        INT(Z'6A43', C_INT16_T),  &
        INT(Z'4EC9', C_INT16_T),  &
        [ INT(Z'B7', C_SIGNED_CHAR), INT(Z'13', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'5A', C_SIGNED_CHAR),  &
          INT(Z'0C', C_SIGNED_CHAR), INT(Z'13', C_SIGNED_CHAR),  &
          INT(Z'B9', C_SIGNED_CHAR), INT(Z'40', C_SIGNED_CHAR) ] )
    
  END FUNCTION bitmapsourcetransform_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICBitmapFrameDecode
  
  
  !*****************************************************************************
  
  FUNCTION bitmapframedecode_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: bitmapframedecode_IID
    
    !***************************************************************************
    
    bitmapframedecode_IID = GUID(  &
        INT(Z'3B16811B', C_INT32_T),  &
        INT(Z'6A43', C_INT16_T),  &
        INT(Z'4EC9', C_INT16_T),  &
        [ INT(Z'A8', C_SIGNED_CHAR), INT(Z'13', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'93', C_SIGNED_CHAR),  &
          INT(Z'0C', C_SIGNED_CHAR), INT(Z'13', C_SIGNED_CHAR),  &
          INT(Z'B9', C_SIGNED_CHAR), INT(Z'40', C_SIGNED_CHAR) ] )
    
  END FUNCTION bitmapframedecode_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICProgressiveLevelControl
  
  
  !*****************************************************************************
  
  FUNCTION progressivelevelcontrol_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: progressivelevelcontrol_IID
    
    !***************************************************************************
    
    progressivelevelcontrol_IID = GUID(  &
        INT(Z'DAAC296F', C_INT32_T),  &
        INT(Z'7AA5', C_INT16_T),  &
        INT(Z'4DBF', C_INT16_T),  &
        [ INT(Z'8D', C_SIGNED_CHAR), INT(Z'15', C_SIGNED_CHAR),  &
          INT(Z'22', C_SIGNED_CHAR), INT(Z'5C', C_SIGNED_CHAR),  &
          INT(Z'59', C_SIGNED_CHAR), INT(Z'76', C_SIGNED_CHAR),  &
          INT(Z'F8', C_SIGNED_CHAR), INT(Z'91', C_SIGNED_CHAR) ] )
    
  END FUNCTION progressivelevelcontrol_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICProgressCallback
  
  
  !*****************************************************************************
  
  FUNCTION progresscallback_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: progresscallback_IID
    
    !***************************************************************************
    
    progresscallback_IID = GUID(  &
        INT(Z'4776F9CD', C_INT32_T),  &
        INT(Z'9517', C_INT16_T),  &
        INT(Z'45FA', C_INT16_T),  &
        [ INT(Z'BF', C_SIGNED_CHAR), INT(Z'24', C_SIGNED_CHAR),  &
          INT(Z'E8', C_SIGNED_CHAR), INT(Z'9C', C_SIGNED_CHAR),  &
          INT(Z'5E', C_SIGNED_CHAR), INT(Z'C5', C_SIGNED_CHAR),  &
          INT(Z'C6', C_SIGNED_CHAR), INT(Z'0C', C_SIGNED_CHAR) ] )
    
  END FUNCTION progresscallback_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICBitmapCodecProgressNotification
  
  
  !*****************************************************************************
  
  FUNCTION bitmapcodecprogressnotification_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: bitmapcodecprogressnotification_IID
    
    !***************************************************************************
    
    bitmapcodecprogressnotification_IID = GUID(  &
        INT(Z'64C1024E', C_INT32_T),  &
        INT(Z'C3CF', C_INT16_T),  &
        INT(Z'4462', C_INT16_T),  &
        [ INT(Z'80', C_SIGNED_CHAR), INT(Z'78', C_SIGNED_CHAR),  &
          INT(Z'88', C_SIGNED_CHAR), INT(Z'C2', C_SIGNED_CHAR),  &
          INT(Z'B1', C_SIGNED_CHAR), INT(Z'1C', C_SIGNED_CHAR),  &
          INT(Z'46', C_SIGNED_CHAR), INT(Z'D9', C_SIGNED_CHAR) ] )
    
  END FUNCTION bitmapcodecprogressnotification_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICComponentInfo
  
  
  !*****************************************************************************
  
  FUNCTION componentinfo_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: componentinfo_IID
    
    !***************************************************************************
    
    componentinfo_IID = GUID(  &
        INT(Z'23BC3F0A', C_INT32_T),  &
        INT(Z'698B', C_INT16_T),  &
        INT(Z'4357', C_INT16_T),  &
        [ INT(Z'88', C_SIGNED_CHAR), INT(Z'6B', C_SIGNED_CHAR),  &
          INT(Z'F2', C_SIGNED_CHAR), INT(Z'4D', C_SIGNED_CHAR),  &
          INT(Z'50', C_SIGNED_CHAR), INT(Z'67', C_SIGNED_CHAR),  &
          INT(Z'13', C_SIGNED_CHAR), INT(Z'34', C_SIGNED_CHAR) ] )
    
  END FUNCTION componentinfo_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICFormatConverterInfo
  
  
  !*****************************************************************************
  
  FUNCTION formatconverterinfo_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: formatconverterinfo_IID
    
    !***************************************************************************
    
    formatconverterinfo_IID = GUID(  &
        INT(Z'9F34FB65', C_INT32_T),  &
        INT(Z'13F4', C_INT16_T),  &
        INT(Z'4F15', C_INT16_T),  &
        [ INT(Z'BC', C_SIGNED_CHAR), INT(Z'57', C_SIGNED_CHAR),  &
          INT(Z'37', C_SIGNED_CHAR), INT(Z'26', C_SIGNED_CHAR),  &
          INT(Z'B5', C_SIGNED_CHAR), INT(Z'E5', C_SIGNED_CHAR),  &
          INT(Z'3D', C_SIGNED_CHAR), INT(Z'9F', C_SIGNED_CHAR) ] )
    
  END FUNCTION formatconverterinfo_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICBitmapCodecInfo
  
  
  !*****************************************************************************
  
  FUNCTION bitmapcodecinfo_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: bitmapcodecinfo_IID
    
    !***************************************************************************
    
    bitmapcodecinfo_IID = GUID(  &
        INT(Z'E87A33C4', C_INT32_T),  &
        INT(Z'B76E', C_INT16_T),  &
        INT(Z'4C47', C_INT16_T),  &
        [ INT(Z'8B', C_SIGNED_CHAR), INT(Z'09', C_SIGNED_CHAR),  &
          INT(Z'29', C_SIGNED_CHAR), INT(Z'8E', C_SIGNED_CHAR),  &
          INT(Z'B1', C_SIGNED_CHAR), INT(Z'2A', C_SIGNED_CHAR),  &
          INT(Z'27', C_SIGNED_CHAR), INT(Z'14', C_SIGNED_CHAR) ] )
    
  END FUNCTION bitmapcodecinfo_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICBitmapEncoderInfo
  
  
  !*****************************************************************************
  
  FUNCTION bitmapencoderinfo_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: bitmapencoderinfo_IID
    
    !***************************************************************************
    
    bitmapencoderinfo_IID = GUID(  &
        INT(Z'94C9B4EE', C_INT32_T),  &
        INT(Z'A09F', C_INT16_T),  &
        INT(Z'4F92', C_INT16_T),  &
        [ INT(Z'8A', C_SIGNED_CHAR), INT(Z'1E', C_SIGNED_CHAR),  &
          INT(Z'4A', C_SIGNED_CHAR), INT(Z'9B', C_SIGNED_CHAR),  &
          INT(Z'CE', C_SIGNED_CHAR), INT(Z'7E', C_SIGNED_CHAR),  &
          INT(Z'76', C_SIGNED_CHAR), INT(Z'FB', C_SIGNED_CHAR) ] )
    
  END FUNCTION bitmapencoderinfo_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICBitmapDecoderInfo
  
  
  !*****************************************************************************
  
  FUNCTION bitmapdecoderinfo_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: bitmapdecoderinfo_IID
    
    !***************************************************************************
    
    bitmapdecoderinfo_IID = GUID(  &
        INT(Z'D8CD007F', C_INT32_T),  &
        INT(Z'D08F', C_INT16_T),  &
        INT(Z'4191', C_INT16_T),  &
        [ INT(Z'9B', C_SIGNED_CHAR), INT(Z'FC', C_SIGNED_CHAR),  &
          INT(Z'23', C_SIGNED_CHAR), INT(Z'6E', C_SIGNED_CHAR),  &
          INT(Z'A7', C_SIGNED_CHAR), INT(Z'F0', C_SIGNED_CHAR),  &
          INT(Z'E4', C_SIGNED_CHAR), INT(Z'B5', C_SIGNED_CHAR) ] )
    
  END FUNCTION bitmapdecoderinfo_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICPixelFormatInfo
  
  
  !*****************************************************************************
  
  FUNCTION pixelformatinfo_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: pixelformatinfo_IID
    
    !***************************************************************************
    
    pixelformatinfo_IID = GUID(  &
        INT(Z'E8EDA601', C_INT32_T),  &
        INT(Z'3D48', C_INT16_T),  &
        INT(Z'431A', C_INT16_T),  &
        [ INT(Z'AB', C_SIGNED_CHAR), INT(Z'44', C_SIGNED_CHAR),  &
          INT(Z'69', C_SIGNED_CHAR), INT(Z'05', C_SIGNED_CHAR),  &
          INT(Z'9B', C_SIGNED_CHAR), INT(Z'E8', C_SIGNED_CHAR),  &
          INT(Z'8B', C_SIGNED_CHAR), INT(Z'BE', C_SIGNED_CHAR) ] )
    
  END FUNCTION pixelformatinfo_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICPixelFormatInfo2
  
  
  !*****************************************************************************
  
  FUNCTION pixelformatinfo2_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: pixelformatinfo2_IID
    
    !***************************************************************************
    
    pixelformatinfo2_IID = GUID(  &
        INT(Z'A9DB33A2', C_INT32_T),  &
        INT(Z'AF5F', C_INT16_T),  &
        INT(Z'43C7', C_INT16_T),  &
        [ INT(Z'B6', C_SIGNED_CHAR), INT(Z'79', C_SIGNED_CHAR),  &
          INT(Z'74', C_SIGNED_CHAR), INT(Z'F5', C_SIGNED_CHAR),  &
          INT(Z'98', C_SIGNED_CHAR), INT(Z'4B', C_SIGNED_CHAR),  &
          INT(Z'5A', C_SIGNED_CHAR), INT(Z'A4', C_SIGNED_CHAR) ] )
    
  END FUNCTION pixelformatinfo2_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICImagingFactory
  
  
  !*****************************************************************************
  
  FUNCTION imagingfactory_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: imagingfactory_IID
    
    !***************************************************************************
    
    imagingfactory_IID = GUID(  &
        INT(Z'EC5EC8A9', C_INT32_T),  &
        INT(Z'C395', C_INT16_T),  &
        INT(Z'4314', C_INT16_T),  &
        [ INT(Z'9C', C_SIGNED_CHAR), INT(Z'77', C_SIGNED_CHAR),  &
          INT(Z'54', C_SIGNED_CHAR), INT(Z'D7', C_SIGNED_CHAR),  &
          INT(Z'A9', C_SIGNED_CHAR), INT(Z'35', C_SIGNED_CHAR),  &
          INT(Z'FF', C_SIGNED_CHAR), INT(Z'70', C_SIGNED_CHAR) ] )
    
  END FUNCTION imagingfactory_IID
  
  
  !*****************************************************************************
  
  SUBROUTINE CreateDecoderFromFilename_utf8( factory, wzFilename,  &
      dwDesiredAccess, metadataOptions, ppIDecoder, hr, pguidVendor )
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_F_POINTER, C_F_PROCPOINTER
    
    !---------------------------------------------------------------------------
    ! Arguments
    
    CLASS(IWICImagingFactory), INTENT(IN) :: factory
    
    CHARACTER(*), INTENT(IN) :: wzFilename
    
    INTEGER(DWORD), INTENT(IN) :: dwDesiredAccess
    
    INTEGER(WICDecodeOptions), INTENT(IN) :: metadataOptions
    
    TYPE(IWICBitmapDecoder), INTENT(OUT) :: ppIDecoder
    
    INTEGER(HRESULT), INTENT(OUT) :: hr
    
    TYPE(GUID), INTENT(IN), OPTIONAL :: pguidVendor
    
    !***************************************************************************
    
    CALL CreateDecoderFromFilename(  &
        factory,  &
        UTF8ToUTF16(wzFilename),  &
        dwDesiredAccess,  &
        metadataOptions,  &
        ppIDecoder,  &
        hr,  &
        pguidVendor )
    
  END SUBROUTINE CreateDecoderFromFilename_utf8
  
  
  !*****************************************************************************
  
  SUBROUTINE CreateDecoderFromFilename_utf16( factory, wzFilename,  &
      dwDesiredAccess, metadataOptions, ppIDecoder, hr, pguidVendor )
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY:  &
        C_F_POINTER,  &
        C_F_PROCPOINTER,  &
        C_LOC,  &
        C_NULL_PTR
    
    !---------------------------------------------------------------------------
    ! Arguments
    
    CLASS(IWICImagingFactory), INTENT(IN) :: factory
    
    INTEGER(WCHAR), INTENT(IN) :: wzFilename(:)
    
    INTEGER(DWORD), INTENT(IN) :: dwDesiredAccess
    
    INTEGER(WICDecodeOptions), INTENT(IN) :: metadataOptions
    
    TYPE(IWICBitmapDecoder), INTENT(OUT) :: ppIDecoder
    
    INTEGER(HRESULT), INTENT(OUT) :: hr
    
    TYPE(GUID), INTENT(IN), OPTIONAL, TARGET :: pguidVendor
  
    !---------------------------------------------------------------------------
    ! Locals
    
    INTEGER(WCHAR) :: local_filename(SIZE(wzFilename) + 1)
    
    TYPE(C_PTR) :: local_vendor
    
    TYPE(IWICImagingFactoryVTbl), POINTER :: ptbl
    PROCEDURE(CreateDecoderFromFilename_intf), POINTER :: proc
    
    !***************************************************************************
    
    local_filename = [ wzFilename, 0_WCHAR ]
    
    IF (PRESENT(pguidVendor)) THEN
      local_vendor = C_LOC(pguidVendor)
    ELSE
      local_vendor = C_NULL_PTR
    END IF
    
    CALL C_F_POINTER(VTable(factory), ptbl)
    CALL C_F_PROCPOINTER(ptbl%CreateDecoderFromFilename, proc)
    hr = proc(  &
        factory%object,  &
        local_filename,  &
        local_vendor,  &
        dwDesiredAccess,  &
        metadataOptions,  &
        ppIDecoder%object )
    
  END SUBROUTINE CreateDecoderFromFilename_utf16
  
  
  !*****************************************************************************
  
  SUBROUTINE CreateFormatConverter(factory, ppIFormatConverter, hr)
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY:  &
        C_F_POINTER,  &
        C_F_PROCPOINTER,  &
        C_LOC,  &
        C_NULL_PTR
    
    !---------------------------------------------------------------------------
    ! Arguments
    
    CLASS(IWICImagingFactory), INTENT(IN) :: factory
    
    TYPE(IWICFormatConverter), INTENT(OUT) :: ppIFormatConverter
    
    INTEGER(HRESULT), INTENT(OUT) :: hr
  
    !---------------------------------------------------------------------------
    ! Locals
    
    TYPE(IWICImagingFactoryVTbl), POINTER :: ptbl
    PROCEDURE(CreateFormatConverter_intf), POINTER :: proc
    
    !***************************************************************************
    
    CALL C_F_POINTER(VTable(factory), ptbl)
    CALL C_F_PROCPOINTER(ptbl%CreateFormatConverter, proc)
    hr = proc(  &
        factory%object,  &
        ppIFormatConverter%object )
    
  END SUBROUTINE CreateFormatConverter
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICDevelopRawNotificationCallback
  
  
  !*****************************************************************************
  
  FUNCTION developrawnotificationcallback_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: developrawnotificationcallback_IID
    
    !***************************************************************************
    
    developrawnotificationcallback_IID = GUID(  &
        INT(Z'95C75A6E', C_INT32_T),  &
        INT(Z'3E8C', C_INT16_T),  &
        INT(Z'4EC2', C_INT16_T),  &
        [ INT(Z'85', C_SIGNED_CHAR), INT(Z'A8', C_SIGNED_CHAR),  &
          INT(Z'AE', C_SIGNED_CHAR), INT(Z'BC', C_SIGNED_CHAR),  &
          INT(Z'C5', C_SIGNED_CHAR), INT(Z'51', C_SIGNED_CHAR),  &
          INT(Z'E5', C_SIGNED_CHAR), INT(Z'9B', C_SIGNED_CHAR) ] )
    
  END FUNCTION developrawnotificationcallback_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IWICDevelopRaw
  
  
  !*****************************************************************************
  
  FUNCTION developraw_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: developraw_IID
    
    !***************************************************************************
    
    developraw_IID = GUID(  &
        INT(Z'FBEC5E44', C_INT32_T),  &
        INT(Z'F7BE', C_INT16_T),  &
        INT(Z'4B65', C_INT16_T),  &
        [ INT(Z'B7', C_SIGNED_CHAR), INT(Z'F8', C_SIGNED_CHAR),  &
          INT(Z'C0', C_SIGNED_CHAR), INT(Z'C8', C_SIGNED_CHAR),  &
          INT(Z'1F', C_SIGNED_CHAR), INT(Z'EF', C_SIGNED_CHAR),  &
          INT(Z'02', C_SIGNED_CHAR), INT(Z'6D', C_SIGNED_CHAR) ] )
    
  END FUNCTION developraw_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Other stand-alone functions
  
  
  !*****************************************************************************
  
  SUBROUTINE WICCreateFactory(factory, hr)
    
    !---------------------------------------------------------------------------
    ! Arguments
    
    TYPE(IWICImagingFactory), INTENT(OUT) :: factory
    INTEGER(HRESULT), INTENT(OUT) :: hr
    
    !***************************************************************************
    
    CALL CoCreateInstance(CLSID_WICImagingFactory, factory, hr)
    
  END SUBROUTINE WICCreateFactory
  
END MODULE WinImagingComponent
